using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;
namespace CallCenterApi.DAL
{
	/// <summary>
	/// 数据访问类:T_Sms_SmsModel
	/// </summary>
	public partial class T_Sms_SmsModel
	{
		public T_Sms_SmsModel()
		{}
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int ModelId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sms_SmsModel");
            strSql.Append(" where ModelId=@ModelId");
            SqlParameter[] parameters = {
					new SqlParameter("@ModelId", SqlDbType.Int,4)
			};
            parameters[0].Value = ModelId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sms_SmsModel model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sms_SmsModel(");
            strSql.Append("Name,Contents,AddPeople,AddTime,TypeId,EditPeople,EditTime,State)");
            strSql.Append(" values (");
            strSql.Append("@Name,@Contents,@AddPeople,@AddTime,@TypeId,@EditPeople,@EditTime,@State)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@Name", SqlDbType.NVarChar,50),
					new SqlParameter("@Contents", SqlDbType.Text),
					new SqlParameter("@AddPeople", SqlDbType.NVarChar,50),
					new SqlParameter("@AddTime", SqlDbType.DateTime),
					new SqlParameter("@TypeId", SqlDbType.Int,4),
					new SqlParameter("@EditPeople", SqlDbType.NVarChar,50),
					new SqlParameter("@EditTime", SqlDbType.DateTime),
					new SqlParameter("@State", SqlDbType.NChar,10)};
            parameters[0].Value = model.Name;
            parameters[1].Value = model.Contents;
            parameters[2].Value = model.AddPeople;
            parameters[3].Value = model.AddTime;
            parameters[4].Value = model.TypeId;
            parameters[5].Value = model.EditPeople;
            parameters[6].Value = model.EditTime;
            parameters[7].Value = model.State;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sms_SmsModel model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sms_SmsModel set ");
            strSql.Append("Name=@Name,");
            strSql.Append("Contents=@Contents,");
            strSql.Append("AddPeople=@AddPeople,");
            strSql.Append("AddTime=@AddTime,");
            strSql.Append("TypeId=@TypeId,");
            strSql.Append("EditPeople=@EditPeople,");
            strSql.Append("EditTime=@EditTime,");
            strSql.Append("State=@State");
            strSql.Append(" where ModelId=@ModelId");
            SqlParameter[] parameters = {
					new SqlParameter("@Name", SqlDbType.NVarChar,50),
					new SqlParameter("@Contents", SqlDbType.Text),
					new SqlParameter("@AddPeople", SqlDbType.NVarChar,50),
					new SqlParameter("@AddTime", SqlDbType.DateTime),
					new SqlParameter("@TypeId", SqlDbType.Int,4),
					new SqlParameter("@EditPeople", SqlDbType.NVarChar,50),
					new SqlParameter("@EditTime", SqlDbType.DateTime),
					new SqlParameter("@State", SqlDbType.NChar,10),
					new SqlParameter("@ModelId", SqlDbType.Int,4)};
            parameters[0].Value = model.Name;
            parameters[1].Value = model.Contents;
            parameters[2].Value = model.AddPeople;
            parameters[3].Value = model.AddTime;
            parameters[4].Value = model.TypeId;
            parameters[5].Value = model.EditPeople;
            parameters[6].Value = model.EditTime;
            parameters[7].Value = model.State;
            parameters[8].Value = model.ModelId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int ModelId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sms_SmsModel ");
            strSql.Append(" where ModelId=@ModelId");
            SqlParameter[] parameters = {
					new SqlParameter("@ModelId", SqlDbType.Int,4)
			};
            parameters[0].Value = ModelId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string ModelIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sms_SmsModel ");
            strSql.Append(" where ModelId in (" + ModelIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sms_SmsModel GetModel(int ModelId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 ModelId,Name,Contents,AddPeople,AddTime,TypeId,EditPeople,EditTime,State from T_Sms_SmsModel ");
            strSql.Append(" where ModelId=@ModelId");
            SqlParameter[] parameters = {
					new SqlParameter("@ModelId", SqlDbType.Int,4)
			};
            parameters[0].Value = ModelId;

            CallCenterApi.Model.T_Sms_SmsModel model = new CallCenterApi.Model.T_Sms_SmsModel();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["ModelId"] != null && ds.Tables[0].Rows[0]["ModelId"].ToString() != "")
                {
                    model.ModelId = int.Parse(ds.Tables[0].Rows[0]["ModelId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["Name"] != null && ds.Tables[0].Rows[0]["Name"].ToString() != "")
                {
                    model.Name = ds.Tables[0].Rows[0]["Name"].ToString();
                }
                if (ds.Tables[0].Rows[0]["Contents"] != null && ds.Tables[0].Rows[0]["Contents"].ToString() != "")
                {
                    model.Contents = ds.Tables[0].Rows[0]["Contents"].ToString();
                }
                if (ds.Tables[0].Rows[0]["AddPeople"] != null && ds.Tables[0].Rows[0]["AddPeople"].ToString() != "")
                {
                    model.AddPeople = ds.Tables[0].Rows[0]["AddPeople"].ToString();
                }
                if (ds.Tables[0].Rows[0]["AddTime"] != null && ds.Tables[0].Rows[0]["AddTime"].ToString() != "")
                {
                    model.AddTime = DateTime.Parse(ds.Tables[0].Rows[0]["AddTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["TypeId"] != null && ds.Tables[0].Rows[0]["TypeId"].ToString() != "")
                {
                    model.TypeId = int.Parse(ds.Tables[0].Rows[0]["TypeId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["EditPeople"] != null && ds.Tables[0].Rows[0]["EditPeople"].ToString() != "")
                {
                    model.EditPeople = ds.Tables[0].Rows[0]["EditPeople"].ToString();
                }
                if (ds.Tables[0].Rows[0]["EditTime"] != null && ds.Tables[0].Rows[0]["EditTime"].ToString() != "")
                {
                    model.EditTime = DateTime.Parse(ds.Tables[0].Rows[0]["EditTime"].ToString());
                }
                if (ds.Tables[0].Rows[0]["State"] != null && ds.Tables[0].Rows[0]["State"].ToString() != "")
                {
                    model.State = ds.Tables[0].Rows[0]["State"].ToString();
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ModelId,Name,Contents,AddPeople,AddTime,TypeId,EditPeople,EditTime,State ");
            strSql.Append(" FROM T_Sms_SmsModel ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" ModelId,Name,Contents,AddPeople,AddTime,TypeId,EditPeople,EditTime,State ");
            strSql.Append(" FROM T_Sms_SmsModel ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sms_SmsModel ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.ModelId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sms_SmsModel T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Sms_SmsModel";
            parameters[1].Value = "ModelId";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
	}
}

